
/*
 * $Id: StatSoft.cc,v 1.1.1.3 1999/03/08 07:56:06 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include "StatSoft.h"
#include "Clock.h"
#include "ILog.h"
#include "OLog.h"
#include "logTags.h"
#include "globals.h"

/* StatSoftRec */

void StatSoftRec::store(OLog &log) const {
	Assert(theDuration >= 0);
	log << theXactLifeTime << theConnLifeTime << theDuration;
}

void StatSoftRec::load(ILog &log) {
	log >> theXactLifeTime >> theConnLifeTime >> theDuration;
}

void StatSoftRec::restart() {
	theXactLifeTime.reset();
	theConnLifeTime.reset();
}

StatSoftRec &StatSoftRec::operator +=(const StatSoftRec &r) {
	theXactLifeTime.add(r.theXactLifeTime);
	theConnLifeTime.add(r.theConnLifeTime);
	// do not update duration

	return *this;
}


/* StatSoft */

StatSoft::StatSoft(Time aPeriod): StatClockInt(aPeriod) {
}

void StatSoft::flush() {
	theDuration = TheClock - theIntStart;

	OLog &log = TheLog();
	log << bege(lgStatSoft);
	StatSoftRec::store(log);
	log << ende;
}

void StatSoft::restart() {
	StatClockInt::restart();
	StatSoftRec::restart();
}
