
/*
 * $Id: Server.h,v 1.21 1999/04/20 23:10:16 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef SERVER_CLASS_H
#define SERVER_CLASS_H

#include "Socket.h"
#include "Select.h"
#include "Farm.h"
#include "SrvXact.h"
#include "SrvConnMgr.h"

class ListenQueue;
class RndDistr;

class Server: public Select::User, public SrvConnMgr::User {
	public:
		Server();
		~Server();

		void configure(int aPort, RndDistr *aThinkDistr);
		void listenQueue(ListenQueue *aQueue);
		void start();

		void noteXactDone(SrvXact *x);

		virtual void noteReadReady(int fd);
		virtual void noteWriteReady(int fd);
		virtual void noteConnReady(Connection *conn);

	protected:
		void startXact(Connection *conn);
		void deaf();

	protected:
		ObjFarm<SrvXact> theXacts;
		ListenQueue *theLQueue;
		SrvConnMgr *theConnMgr;
		RndDistr *theThinkDistr;
		Socket theSock;
		int thePort;

		SelectReserv theReserv;
};

#endif
