
/*
 * $Id: SrvConnMgr.h,v 1.2 1999/04/20 23:10:18 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef SRV_CONN_MGR_H
#define SRV_CONN_MGR_H

#include "Farm.h"
#include "Select.h"
#include "Connection.h"

class SrvConnMgr: public Select::User {
	public:
		class User {
			public:
				virtual ~User() {}
				virtual void noteConnReady(Connection *conn) = 0;
		};

	public:
		SrvConnMgr(User *aUser);
		virtual ~SrvConnMgr();

		Connection *get(Socket &s, bool &fatal);
		void put(Connection *);

		virtual void noteReadReady(int fd);
		
	protected:
		void close(Connection *);

		void justOpened(Connection *conn);
		void aboutToClose(Connection *conn);

		void setUseLimit(Connection *conn);
		void keepOpen(Connection *conn);

	protected:
		ObjFarm<Connection> theConns;
		Array<Connection*> theConnIdx; // fd -> conn map
		Array<int> theRPortStamps; // secs since program start, actually

		User *theUser;
};

#endif
