
/*
 * $Id: StatSoft.h,v 1.1.1.3 1999/03/08 07:56:14 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef STAT_SOFT_H
#define STAT_SOFT_H

#include "StatInt.h"
#include "histograms.h"

// Accumulates "expensive" stats (in StatSoftRec) and dumps them every So OFTen

class StatSoftRec {
	public:
		void restart();
		void store(OLog &log) const;
		void load(ILog &);

		void xactLifeTime(const Time &tm) { theXactLifeTime.record(tm); }
		void connLifeTime(const Time &tm) { theConnLifeTime.record(tm); }

		StatSoftRec &operator +=(const StatSoftRec &s);

		const TimeHist &xactLifeTime() const { return theXactLifeTime; }
		const TimeHist &connLifeTime() const { return theConnLifeTime; }
		// XXX: msec
		double xactLifeTimeMean() const { return xactLifeTime().stats().mean(); }

	protected:
		TimeHist theXactLifeTime;
		TimeHist theConnLifeTime;
		Time theDuration;    // actual duration computed in flush()
};

class StatSoft: public StatClockInt, public StatSoftRec {
	public:
		StatSoft(Time aPeriod);

		virtual void flush();

	protected:
		virtual void restart();
};

#endif
